#!/bin/sh

# The first two rules should not be changed, they will affect
# the calibration of the NTPns daemon.
/sbin/ipfw add 100 allow udp from any to any 123
/sbin/ipfw add 200 allow udp from any 123 to any

# Allow outgoing "record"
/sbin/ipfw add 300 allow udp from me to any 5555

# Allow outgoing "rrrd"
/sbin/ipfw add 400 allow udp from me to any 4444

# Allow DNS trafic through
/sbin/ipfw add 500 allow udp from me to any 53
/sbin/ipfw add 600 allow udp from any 53 to me

# Allow SNMP trafic through
/sbin/ipfw add 700 allow udp from me 161 to any 
/sbin/ipfw add 800 allow udp from any to me 161
/sbin/ipfw add 900 allow udp from me to any 162

# Allow outgoing ICMP
/sbin/ipfw add 1500 allow icmp from me to any

# Allow SSH sessions ingoing
/sbin/ipfw add 2000 allow tcp from any to me 22
/sbin/ipfw add 2100 allow tcp from me 22 to any

# Allow outgoing TCP trafic
/sbin/ipfw add 2200 allow tcp from any to me established
/sbin/ipfw add 2300 allow tcp from me to any

# Allow local telnet to NTPns, disallow everybody else
/sbin/ipfw add 2400 allow tcp from 127.0.0.1 to me 123
/sbin/ipfw add 2500 allow tcp from me 123 to 127.0.0.1
/sbin/ipfw add 2600 deny tcp from any to me 123

# Deny everything else
/sbin/ipfw add 5000 deny ip from any to any
