/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <phk@FreeBSD.ORG> wrote this file.  As long as you retain this notice you
 * can do whatever you want with this stuff. If we meet some day, and you think
 * this stuff is worth it, you can buy me a beer in return.   Poul-Henning Kamp
 * ----------------------------------------------------------------------------
 * $Id: shmem.h,v 1.8 2004/05/24 08:05:39 phk Exp $
 *
 * This file defines the shared memory layout used for the SNMP agent
 *
 */

#include <sys/queue.h>

#define SHMEM_FILENAME	"/tmp/ntpns.shmem"

struct shmem {
	u_int			tag;
	u_int			length;
	struct shmem		*ptr;
	TAILQ_ENTRY(shmem)	next;
};

#define ID_TAG 0x49440000

struct ntpns_id {
	pid_t			pid;
	u_char			magic[33];
	u_int			major;
	u_int			minor;
};

#define PEER_TAG 0x50454552

struct ntpns_peer {
	int		ntpPeersAssocId;
	int		ntpPeersConfigured;
	uint32_t	ntpPeersPeerAddress;
        int32_t		ntpPeersPeerPort;
        uint32_t	ntpPeersHostAddress;
        int32_t		ntpPeersHostPort;
        u_int		ntpPeersLeap;
        u_int		ntpPeersMode;
        u_int		ntpPeersStratum;
        u_int		ntpPeersPeerPoll;
        u_int		ntpPeersHostPoll;
        int		ntpPeersPrecision;
        int32_t		ntpPeersRootDelay;
        uint32_t	ntpPeersRootDispersion;
        uint8_t		ntpPeersRefId[4];
        uint64_t	ntpPeersRefTime;
        uint64_t	ntpPeersOrgTime;
        uint64_t	ntpPeersReceiveTime;
        uint64_t	ntpPeersTransmitTime;
        uint32_t	ntpPeersUpdateTime;
        uint32_t	ntpPeersReach;
        uint32_t	ntpPeersTimer;
        int32_t		ntpPeersOffset;
        int32_t		ntpPeersDelay;
        uint32_t	ntpPeersDispersion;
        uint32_t	ntpPeersFilterValidEntries;
        uint32_t	ntpPeersEntryStatus;

};

#define NTP_TAG 0x4e545000

struct ntpns_shmem {
	/* ntpSystem group */
	u_int		ntpSysLeap;
	u_int		ntpSysStratum;
	int		ntpSysPrecision;
	int32_t		ntpSysRootDelay;
	uint32_t	ntpSysRootDispersion;
	uint8_t		ntpRefId[4];
	uint64_t	ntpSysRefTime;
	u_int		ntpSysPoll;
	int		ntpSysPeer;
	uint64_t	ntpSysClock;

	int		clockstate;
	int		clocksource;
};
