/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <phk@FreeBSD.ORG> wrote this file.  As long as you retain this notice you
 * can do whatever you want with this stuff. If we meet some day, and you think
 * this stuff is worth it, you can buy me a beer in return.   Poul-Henning Kamp
 * ----------------------------------------------------------------------------
 * $Id: timestamp.h,v 1.1 2004/08/09 20:22:46 phk Exp $
 *
 * This file exposes the API for refclocks and other plugins.
 */

#ifndef __NTPNS_TIMESTAMP_H
#define __NTPNS_TIMESTAMP_H

struct ts {
	enum TsFormat {
		TS_INVALID,
		TS_TIMEVAL,
		TS_TIMESPEC,
		TS_NTPTIME,
		TS_BINTIME
	} fmt;
	union {
		struct timeval	tv;
		struct timespec	ts;
		struct bintime	bt;
		uint64_t	ntp;
	} ts;
};

void TsNormalize(struct ts *t);
void TsTimeval(struct ts *t, struct timeval *tv);
void TsTimespec(struct ts *t, struct timespec *ts);
void TsNTPtime(struct ts *t, uint64_t *nt);
char *TsFormat(struct ts *t, char *buf);
double TsDiff(struct ts *t1, struct ts *t2);
uint64_t TsNTPNow(void);

#endif /* __NTPNS_TIMESTAMP_H */
