NODE telnet {
	name config_telnet
	desc "TELNET remote configuration interface"
	WORD host WORD {
		desc "Hostname to listen on"
		func cfg_telnet_host
	}
	WORD port WORD {
		desc "Port number to listen on"
		func cfg_telnet_port
	}
	WORD enable {
		desc "Enable TELNET remote configuration interface"
		func cfg_telnet_enable
	}
}
WORD exit {
	name config_exit
	desc "Close this configuration connection"
	func cfg_config_exit
}
WORD close {
	name config_close
	desc "Close this configuration connection"
	func cfg_config_exit
}

WORD load WORD {
	name config_load
	func cfg_load
	desc "Load software modules"
}

NODE pps {
	name config_pps
	desc "PPS-API device configuration"

	WORD flank ENUM { assert clear } {
		desc "Which flank {assert,clear} is on time"
		func config_pps_flank
	}
	WORD offset REAL {
		desc "Offset compensation value [sec] (postive = too late)"
		func config_pps_offset
	}
	WORD device WORD {
		desc "PPS device file name"
		func config_pps_device
	}
}

NODE source {
	name config_source_subr
	desc "Source configuration"
	show show_source

	WORD limit REAL {
		desc "offset limit [sec]"
		func config_source_limit
	}
	NODE allan {
		desc "Show allan variance"
		show show_source_allan
	}
	NODE data {
		desc "Show data points"
		show show_source_data
	}
	WORD rrrd {
		desc "Configure RRRD"
		func config_source_rrrd
	}
}

WORD pllmath ENUM { b0 be ce mj0 dl0 go3 t3 wamin wamax restart } REAL {
	name config_pllmath
	desc "PLL paramters"
	func cfg_pllmath
	show show_pllmath
}

NODE rrrd {
	name config_rrrd
	desc "Remote RRD configuration"
	WORD port WORD {
		desc	"Destination UDP port"
		func	cfg_rrrd_port
	}
	WORD host WORD {
		desc	"Destination host"
		func	cfg_rrrd_host
	}
	WORD prefix WORD {
		desc	"Directory prefix string"
		func	cfg_rrrd_prefix
	}
	WORD resources {
		desc	"Enable system resource monitoring"
		func	cfg_rrrd_resources
	}
	WORD enable {
		desc	"Enable remote RRD"
		func	cfg_rrrd_enable
	}
}

NODE record {
	name config_record
	desc "Remote recording configuration"
	WORD port WORD {
		desc "destination UDP port"
		func	cfg_record_port
	}
	WORD host WORD {
		desc "destination host"
		func	cfg_record_host
	}
	WORD enable {
		desc "Enable remote recording"
		func	cfg_record_enable
	}
}

INSTANCE msg WORD {
	desc	"Logging and debugging messages"
	name	config_msg
	head	cfg_msg_head
	new	cfg_msg_new
	show	cfg_msg_show

	WORD enable {
		desc	"Enable these messages"
		func	cfg_msg_enable
	}
	WORD disable {
		desc	"Disable these messages"
		func	cfg_msg_disable
	}
	WORD term {
		desc	"Send these messages to the current terminal"
		func	cfg_msg_term
	}
	WORD stdout {
		desc	"Send these messages to stdout"
		func	cfg_msg_stdout
	}
	WORD stderr {
		desc	"Send these messages to stderr"
		func	cfg_msg_stderr
	}
	WORD syslog ENUM {
	    emergency alert critical error warning notice info debug} {
		desc	"Send these messages to syslog"
		func	cfg_msg_syslog
	}
}

INSTANCE source WORD {
	desc	"Time sources"
	name	config_source
	head	cfg_source_head
	new	cfg_source_new
	show	cfg_source_show

	NODE allan {
		desc "Allan variance"
		show show_source_allan
	}
	NODE data {
		desc "Show data points"
		show show_source_data
	}
}

WORD leap {
	name	config_leap
	desc	"Show leap second status"
	func	cfg_leap
}

NODE led {
	name config_led
	desc "Front panel LED configuration"

	WORD running WORD {
		desc "device name of 'RUNNING' led"
		func cfg_led_running
	}
	WORD no_source WORD {
		desc "device name of 'NO_SOURCE' led"
		func cfg_led_no_source
	}
	WORD no_lock WORD {
		desc "device name of 'NO_LOCK' led"
		func cfg_led_no_lock
	}
	WORD time_sync WORD {
		desc "device name of 'TIME SYNC' led"
		func cfg_led_time_sync
	}
	WORD utc_second WORD {
		desc "device name of 'UTC SECOND' led"
		func cfg_led_utc_second
	}
}

WORD watchdog REAL {
	name config_watchdog
	desc "Configure watchdog timeout"
	func cfg_watchdog
}

WORD isc_debug UINT {
	name config_isc_debug
	desc "Set ISC eventlib debugging level"
	func cfg_isc_debug
}
