/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <phk@FreeBSD.ORG> wrote this file.  As long as you retain this notice you
 * can do whatever you want with this stuff. If we meet some day, and you think
 * this stuff is worth it, you can buy me a beer in return.   Poul-Henning Kamp
 * ----------------------------------------------------------------------------
 * $Id: ntpv4.c,v 1.36 2005/09/22 08:06:03 phk Exp $
 */

#include <err.h>
#include <fcntl.h>
#include <errno.h>
#include <stdio.h>
#include <stdint.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <configkit.h>
#include <isc/eventlib.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/endian.h>
#include <netinet/in.h>

#include <ntpns.h>
#include <ntpv4.h>
#include "ntpv4_cfg.h"

struct logh *lsocket, *lpacket, *lpartner;

struct ck_instance *
ntpv4_new(CK_ARG, u_int unit)
{
	struct instance *ip;

	ip = calloc(sizeof *ip, 1);
	if (ip == NULL) {
		nomem();
		return (NULL);
	}
	ip->magic = NTPV4_MAGIC;
	ip->unit = unit;
	TAILQ_INIT(&ip->servers);
	ip->cki.obj = ip;
	return (&ip->cki);
}

mod_init_t ntpv4_init;

const char *
ntpv4_init(void)
{
	static int once = 0;

	if (once) {
		warnx("ntpv4 module already loaded");
		return (NULL);
	} else {
		once = 1;
	}

	ck_TreeAdd(cft, &ntpv4_config);

	lsocket = LogNewHandle("ntpv4_socket");
	lpacket = LogNewHandle("ntpv4_packet");
	lpartner = LogNewHandle("ntpv4_partner");

	return (MAGIC);
}

int
ntpv4_show(CK_ARG)
{
	struct instance *ip;

	ip = cfa->priv;	
	Assert(ip->magic == NTPV4_MAGIC, ("Wrong NTPv4 magic"));
	return (0);
}
