/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <phk@FreeBSD.ORG> wrote this file.  As long as you retain this notice you
 * can do whatever you want with this stuff. If we meet some day, and you think
 * this stuff is worth it, you can buy me a beer in return.   Poul-Henning Kamp
 * ----------------------------------------------------------------------------
 * $Id: pllsim.c,v 1.3 2004/08/09 20:18:15 phk Exp $
 *
 */


#include <stdio.h>
#include <stdlib.h>

#include "pll.h"

static double
Rnd(void)
{

	return (random() % 2000000) * 1e-6 - 1;
}


int
main(int argc __unused, char **argv __unused)
{
	int n;
	double b, p0, f0, d0, pn, fn, p, f, x, y, t, z;

	p0 = 1e-3;
	p0 = 0;
	f0 = 28e-9;
	d0 = 1e-14;
	pn = 1.0 / (32768000.0 / 4);
	fn = 1e-14;
	n = 100000;

	b = p = f = x = y = z = 0;

	p = p0;
	f = f0;
	t = 0;
	x = 0;

	while (n--) {
		t++;
		p += f;
		f += d0 + Rnd() * fn;

		x += b;
		y = p - x;

		y += Rnd() * pn;

		b = pll_math(-y);
	}
	return (0);
}
